数组
1.只出现一次的数字
Java方法
初级算法 - LeetBook - 力扣(LeetCode)全球极客挚爱的技术成长平台
编辑
思路一:运用按位异或的方法,异或是当两个数的相同二进制位置相同时返回0,不同则返回1,运用这一特性我们可以将nums数组元素进行异或得到单独的数字
class Solution { public int singleNumber(int[] nums) { int target=0; for(int i=0;i<nums.length;i++) { target^=nums[i]; } return target; } }
思路二:运用Set的特性(Set集合中的元素只能存放不同的内容)我们可以将nums数组的每一个元素都存放在Set集合中当add添加失败的时候说明集合中有相同内容的元素这时我们将这个元素remove删除掉从而Set集合中只会有一个元素就是单独的元素
class Solution { public int singleNumber(int[] nums) { //定义Interger类型Set集合 Set<Integer> set=new HashSet<Integer>(); //将nums数组的元素一个个添加到set集合中 for(int num:nums) { //添加失败就是有相同元素的时候 if(!set.add(num)) { //删除重复num set.remove(num); } } //toArray方法返回类型是Object类型,强转为int类型 return (int)set.toArray()[0]; } }
二.两个数组的交集 II
初级算法 - LeetBook - 力扣(LeetCode)全球极客挚爱的技术成长平台
编辑
思路一:使用双指针,先将两个数组进行排序,再从头到尾比较两个数组对应位置的元素是否相同相同的话就存入list中不同就将值较小的数组向后移动一位,在进行比较再将list集合中的元素存入到temp数组中并返回,这样的方法避免了数组定义时大小的问题
也可以使用数组来定义先定义数组的大小为两个数组中最短的大小(使用new方法定义),然后使用copyOfRange方法来定义数组的大小
return Arrays.copyOfRange(temp,0,k);
k是遍历时添加的k个元素。
class Solution { public int[] intersect(int[] nums1, int[] nums2) { //指向两个数组的标记点 int cur1=0; int cur2=0; //两个数组长度 int length1=nums1.length; int length2=nums2.length; int count1=0,count2=0; //对两个数组进行排序 Arrays.sort(nums1); Arrays.sort(nums2); /*这里使用List集合而不是Set或则是int[]数组,因为Set集合只能存放不同内容的元素,而使用int[]数组不知道数组的大小不能进行创建或者创建后步骤更加繁琐*/ //定义List数组泛型是Integer List<Integer> list=new ArrayList<>(); int i=0; while(count1<length1 && count2<length2) { if(nums1[count1]==nums2[count2]) { //相同时进行添加 list.add(nums1[count1]); count1++; count2++; } else if(nums1[count1]<nums2[count2]) { count1++; }else { count2++; } } //下面两个方法都是将list集合的元素加入到int[] temp中,因为这时知道了元素的个数 int[] temp=new int[list.size()]; // for (int j = 0; j < list.size(); j++) { // temp[j]=list.get(j); // } for (int n:list) { temp[i]=list.get(i); i++; } return temp; } }